Attribute VB_Name = "Modul1"
Option Explicit

Public Sub Stueckliste_bereinigen()
Attribute Stueckliste_bereinigen.VB_ProcData.VB_Invoke_Func = " \n14"

    Dim wbstring As String
    Dim ReiterName, Dateiname, Dateiname1, Info As String
    Dim Bezeichnung, ObjektID, ObjektID_neu As String
    Dim Laenge, Breite, Staerke As Single
    Dim i As Long, J As Long, Anzahl As Integer
    Dim Zeilenende As Long
    
    'Reitername = Stcklistenname = Baugruppenname *************
    
    ReiterName = ActiveSheet.Name
    
    'Spalten umsortieren und Anzahl anlegen *******************
    
    Columns(2).Insert
    
    Range("B3").Select
    ActiveCell.FormulaR1C1 = "Anz."
    Columns("H:H").Select  ' Spalte ObjectID linksbndig setzen
    With Selection
        .HorizontalAlignment = xlLeft
        .VerticalAlignment = xlBottom
        .WrapText = False
        .Orientation = 0
        .AddIndent = False
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = False
    End With
 
    'Sub Spaltenbreiten_setzen()

    Rows("1:1").RowHeight = 18
    Columns("A:A").ColumnWidth = 5
    Columns("B:B").ColumnWidth = 5
    Columns("C:C").ColumnWidth = 35
    Columns("D:D").ColumnWidth = 40
    Columns("E:E").ColumnWidth = 6
    Columns("F:F").ColumnWidth = 6
    Columns("G:G").ColumnWidth = 6
    Columns("H:H").EntireColumn.AutoFit
       
    ' Formatierung_Zeile Makro

    Range("A3:H3").Select
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlBottom
        .WrapText = False
        .Orientation = 0
        .AddIndent = False
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = False
    End With
    
    ' Stcklistenbezeichnung
         
    Range("C1").Select
    Selection.Cut
    Range("D1").Select
    ActiveSheet.Paste
    Range("D1").Value = "erstellt am: " & Range("D1").Value
    Range("D1").Select
    With Selection
        .HorizontalAlignment = xlRight
        .VerticalAlignment = xlTop
        .WrapText = False
        .Orientation = 0
        .AddIndent = True
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = True
    End With
    
    Range("A1:C1").Select
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlTop
        .WrapText = False
        .Orientation = 0
        .AddIndent = True
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = True
    End With
    
         Range("A1").Select
         With Selection.Font
            .Size = 10
         End With
         Rows("2:2").Delete
         
         ActiveCell.FormulaR1C1 = "Stckliste zu: " & ReiterName
         Range("H1").Select
                 
    ' Datum eintragen Zelle H1
        
'        ActiveCell.FormulaR1C1 = Date   ' "31/01/2023"
        
                  
    ' Neue Spalte "Anz." alle auf 1 setzen *********************
    
    With ThisWorkbook.Sheets(1)
        Zeilenende = 0
        Range("A1").Activate
        Do While ActiveCell.Offset(Zeilenende, 0).Value <> ""
            Zeilenende = Zeilenende + 1
        Loop

        For i = 3 To Zeilenende
          Range("B" & i).Value = "1"
        Next i
    End With

            
    ' gleiche Objekte summieren
    
    Range("C3").Activate
    i = 0
    Do
        Bezeichnung = ActiveCell.Offset(i, 0).Value
        Laenge = ActiveCell.Offset(i, 2).Value
        Breite = ActiveCell.Offset(i, 3).Value
        Staerke = ActiveCell.Offset(i, 4).Value
        ObjektID = ActiveCell.Offset(i, 5).Value
        
        J = 1
        Do
            If ActiveCell.Offset(i + J, 0).Value = Bezeichnung Then
                If ActiveCell.Offset(i + J, 2).Value = Laenge Then
                    If ActiveCell.Offset(i + J, 3).Value = Breite Then
                        If ActiveCell.Offset(i + J, 4).Value = Staerke Then
                            Anzahl = ActiveCell.Offset(i, -1).Value + 1
                            ActiveCell.Offset(i, -1).Value = Anzahl
                            ObjektID_neu = ObjektID & ", " & ActiveCell.Offset(i + J, 5).Value
                            ActiveCell.Offset(i, 5).Value = ObjektID_neu
                            ObjektID = ObjektID_neu
                            ActiveCell.Offset(i + J, 0).EntireRow.Delete shift:=xlUp
                            J = J - 1
                        End If
                    End If
                End If
            End If
            J = J + 1
        Loop Until ActiveCell.Offset(i + J, 0).Value = ""
        i = i + 1
    Loop Until ActiveCell.Offset(i, 0).Value = ""
    
    ' Neue Tabelle A-Z sortieren **********************
    
    Range("B3:Z" & Zeilenende).Select
    ActiveWorkbook.Worksheets(1).Sort.SortFields.Clear
    ActiveWorkbook.Worksheets(1).Sort.SortFields.Add Key:=Range("C3:C" & Zeilenende _
        ), SortOn:=xlSortOnValues, Order:=xlAscending, DataOption:=xlSortNormal
    With ActiveWorkbook.Worksheets(1).Sort
        .SetRange Range("B3:H" & Zeilenende)
        .Header = xlGuess
        .MatchCase = False
        .Orientation = xlTopToBottom
        .SortMethod = xlPinYin
        .Apply
    End With
    
    Columns("H:H").EntireColumn.AutoFit
    
    ' Pos neu durchnummerieren ************************
    
     With ThisWorkbook.Sheets(1)
        Zeilenende = 0
        Range("A1").Activate
        Do While ActiveCell.Offset(Zeilenende, 0).Value <> ""
            Zeilenende = Zeilenende + 1
        Loop

       For i = 3 To Zeilenende
       Range("A" & i).Value = i - 2
       Next i
    End With

    With ThisWorkbook.Sheets(1)
        Zeilenende = 0
        Range("A1").Activate
        Do While ActiveCell.Offset(Zeilenende, 0).Value <> ""
            Zeilenende = Zeilenende + 1
        Loop
    End With
    
    ' Dateiname_einfgen Makro
    
    Range("C" & Zeilenende + 2).Select
    ActiveCell.FormulaR1C1 = "=CELL(""dateiname"")"
    Dateiname = ActiveCell.Value
    Dateiname1 = Left(Dateiname, Len(Dateiname) - 4) & ".xlsx"
    ActiveCell.Value = Dateiname1
    
    With Selection.Font
        .Size = 8
    End With

    ' Neues Blatt zum Einfgen der Stckliste in TurboCAD erstellen
    
    Range("A1:D" & Zeilenende).Select
    Selection.Copy
    Sheets.Add(After:=Sheets(1)).Name = "TC-Stli"
    Range("A1").Select
    ActiveSheet.Paste
    Columns("A:A").ColumnWidth = 5
    Columns("B:B").ColumnWidth = 5
    Columns("C:C").ColumnWidth = 35
    Columns("D:D").ColumnWidth = 40
    With Selection.Font
        .Name = "ISOCPEUR"
        .Size = 10
        .Strikethrough = False
        .Superscript = False
        .Subscript = False
        .OutlineFont = False
        .Shadow = False
        .Underline = xlUnderlineStyleNone
        .ThemeColor = xlThemeColorLight1
        .TintAndShade = 0
        .ThemeFont = xlThemeFontNone
    End With
    Selection.Font.Italic = True
    With Selection
        .VerticalAlignment = xlTop
        .WrapText = True
    End With

    ' Datei speichern

    Worksheets(1).Activate
    wbstring = Left(Dateiname, Len(Dateiname) - 4) & ".xlsx"
    ActiveWorkbook.SaveAs (wbstring)
    Range("A1").Activate

End Sub





